import psychopy.visual
import psychopy.core
import psychopy.event
import ctypes
import random

#
from psychopy.iohub import launchHubServer,EventConstants
io=launchHubServer(psychopy_monitor_name='default')
display = io.devices.display

win = psychopy.visual.Window(display.getPixelResolution(),
                             monitor=display.getPsychopyMonitorName(), 
                             units=display.getCoordinateType(),
                             screen=display.getIndex(),fullscr=True)

keyboard = io.devices.keyboard
#
msg = psychopy.visual.TextStim(win)
clock = psychopy.core.Clock()

obj = ctypes.windll.LoadLibrary('FbiDio.dll')
device = obj.DioOpen("FBIDIO1",0)
obj.DioOutputByte(device,0,0)

res = []
trialDuration = 1.0
for i in range(100):
    offset = random.random()/2.0+0.2
    msg.setText(str(i+1))
    onFlag = False
    flip_time=win.flip()
    io.clearEvents("all") 
    clock.reset()
    while clock.getTime()<trialDuration:
        
        if clock.getTime()>offset and onFlag == False:
            obj.DioOutputByte(device,0,1)
            onTime = clock.getTime()
            onFlag = True
        
        kb_events = keyboard.getEvents()
        for kb_event in kb_events:
            if kb_event.key == ' ':
                res.append(1000*((kb_event.time-flip_time)-onTime))
                #print kb_event.time, flip_time, onTime
        
        io.clearEvents()
        msg.draw()
        win.flip()
    
    obj.DioOutputByte(device,0,0)
    io.wait(0.1)

obj.DioClose(device)

fp = open('output_iohubgetEvents.txt','w')
for r in res:
    fp.write('%f\n' % (r))
fp.close()

io.quit()
psychopy.core.quit()
